;----------------------------------------------------------------------------
;
; Routines to access I/O in Bank 15.  Can also access anything in Bank 15
; (i.e. ROMs).
;
;----------------------------------------------------------------------------

	.include	"cbm.inc"
	.include	"c128.inc"

	.export		_readbank15
	.export		writebank15, _writebank15
	.importzp	ptr1, tmp1
	.import		popax	

.segment	"LOWCODE"

;----------------------------------------------------------------------------
; Read a byte from an I/O port.  Prototype:
;
; unsigned char __fastcall__ readbank15 (void* addr);
;----------------------------------------------------------------------------

_readbank15:
	sta	ptr1
	stx	ptr1+1
	ldy	#0
	sty	$FF00
	lda	(ptr1),y
	sta	$FF01
	rts

;----------------------------------------------------------------------------
; Write a byte to an I/O port.  Prototype:
;
; unsigned char __fastcall__ writebank15 (void* addr, unsigned char val);
;
; If calling from assembler, use writebank15.  Load the address into ptr1 and
; the value in .A.
;
;----------------------------------------------------------------------------

_writebank15:
	sta	tmp1
	jsr	popax
	sta	ptr1
	stx	ptr1+1
	lda	tmp1
	;ldy	#0
	;sty	$FF00
	;sta	(ptr1),y
	;sta	$FF01
	;rts
writebank15:
	ldy	#0
	sty	$FF00
	sta	(ptr1),y
	sta	$FF01
	rts
	